package ihm;
import logique.*;
import xml.*;
import myEvent.*;
import dialogtool.*;
import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import javax.swing.*;
import org.xml.sax.SAXException;
import javax.swing.event.*;
import javax.swing.text.rtf.*;
import javax.swing.text.html.*;
import print.*;
import splash.*;
import style.*;
/**
 * MainFrame represente la fenetre mere de l'application 
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 6.0
 */
public class MainFrame extends JFrame implements StyleEditBaliseListener,PreferenceListener,ListeTagIhmListener
{	
/**
 * la zone d'edition du texte
 */
 public static boolean MAINDEBUG=false;

protected  TextAreaPane _text1;
/** 
 * la fenetre d'edition des attribut
 */
protected CheckDialog _text2;
/**
 * la fenetre d'edition des styles de balises
 */
protected StyleEditBalise _styleEditBalise;
/**
 * le repertoire courant ou se trouve les fichier
 */
protected File _directorie;

/**
 * la liste des tags (forme graphique)
 */
protected ListeTagIhm  _listetagihm;
        ;
protected EditStyleDialog EditStyle;
protected DTDTree _dtdtree;
protected String _select;
/**
 * la liste des balises 
 */
protected ListeBalise _listeBalise;
//protected ContextMenu _contextmenu;
/**
 * la barre d'outil 
 */
protected JToolBar _toolBar;
/**
 * le menu
 */
protected JMenuBar _menuBar;
/**
 * la liste des tags
 */
protected ListeTag _listetag;
/** 
 * la ligne de statut
 */
protected JLabel _status;
/**
 * le nom du fichier dtd
 */
protected String _dtdfile;
/**
 * le validateur de XML
 */
protected XmlValidator _validator;
/**
 * le lecteur et le validateur de DTD
 */
protected DTDValidator _dtdvalidator;
/**
 * panneau de separation 
 */
protected JSplitPane _split1;
/**
 * panneau de separation 
 */
protected JSplitPane _split2;
/**
 * panneau de separation 
 */
protected JSplitPane _split3;
protected JMenuItem copier_balise;
protected JMenuItem coller_balise;
protected boolean copie_balise;
protected Tag _selectione;          
/**
 * panneau de separation 
 */
protected JSplitPane _split4;
protected StyleButton _style_bouton;
protected JMenu mBalise;
protected JMenuItem _style_Item;
/**
 * boite de dialogue d'edition de preference
 */
protected TabbedPreference _tabbedPref;
protected Preference _pref;
public Vector GetDefaultColor(){/*return _styleEditBalise.GetDefaultColor();*/ return new Vector();}
public void initDefaultColorDialog(Vector v) {/*_styleEditBalise.initDefaultColorDialog(v);*/}
public String getDTDFile(){return _dtdfile;}
public String getDefaultDirectorie(){return _directorie.getAbsolutePath();}
public void setDefaultDirectorie(String s)
{
try
{File f=new File(s);
if (f.isDirectory()) _directorie=f;
 if (MainFrame.MAINDEBUG) System.err.println("DIRECTORIE PAR DEFAULT CHANGER"+s);
}catch (Exception ee){System.err.println("SETDEFAULTDIRECTORUE   "+s+"n est pas valide");};
}

private String makeicon(String icon)
{
String result=new String("icons"+System.getProperty("file.separator")+icon);
return result;
}
private String makepref(String icon)
{
String result=new String("preferences"+System.getProperty("file.separator")+icon);
System.err.println("LECTURE DE "+result);
return result;
}
private Action SaveFile()
{
ImageIcon iconOpen = new ImageIcon(makeicon("export.gif"));
Action toto = new AbstractAction("Save Annoted Document", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	SimpleFilter m_txtFilter=new SimpleFilter("xml","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        Thread runner = new Thread() 
        {
	        public void run() {
        	 if (m_chooser.showSaveDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION)
        	 {MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR)); return;}
            	MainFrame.this.repaint();
            	MainFrame.this._directorie=m_chooser.getCurrentDirectory();File fChoosen;File fChoosenStyle;
if (!m_chooser.getSelectedFile().getAbsolutePath().endsWith(".xml"))
            	{
            		fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".xml");
            		fChoosenStyle = new File(m_chooser.getSelectedFile().getAbsolutePath()+"Style.xml");
            		}
    else{  fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath());
     fChoosenStyle = new File(m_chooser.getSelectedFile().getAbsolutePath().substring(0,m_chooser.getSelectedFile().getAbsolutePath().length()-4)+"Style.xml");
    }
	
		
		
		try {
                	 //_text1.load(fChoosen);
		 		FileWriter t=new FileWriter(fChoosen);
		 		PrintWriter pr=new PrintWriter(t,true);
		 		pr.print(GenerateXML.GenerateXML(_text1.getDocument(),_listetag,_dtdfile,_dtdtree));
		 		pr.close();
		 		t.close();
		 		 t=new FileWriter(fChoosenStyle);
		 		 pr=new PrintWriter(t,true);
		 		 _listeBalise.WriteXML(pr);
		 		 pr.close();
		 		t.close();
		 		 
		 		
			}
            	catch (Exception ex) {System.out.println(ex);}
            	MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        }
};
runner.run();

	//System.out.println(GenerateXML.GenerateXML(_text1.getDocument(),_listetag));
	};

};
return (toto);


}


private Action Save()
{
ImageIcon iconOpen = new ImageIcon(makeicon("saveb.gif"));
Action toto = new AbstractAction("Save Balise ", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{try{
	
	PrintWriter h=new PrintWriter(new FileOutputStream("test.xml"));
	
	h.close();
	
	SimpleFilter m_txtFilter=new SimpleFilter("sav","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showSaveDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION) {
         	
            
            File fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".sav");
	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

	FileOutputStream ostream = new FileOutputStream(fChoosen);
	ObjectOutputStream p = new ObjectOutputStream(ostream);

  	   p.writeUTF(_dtdfile);
           p.writeObject(_listeBalise);
           p.close();
           }
           
           MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
           }
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}

private Action SaveDefaultStyle()
{
ImageIcon iconOpen = new ImageIcon(makeicon("saveb.gif"));
Action toto = new AbstractAction("Save as DefaultStyle ", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	try {
      PrintWriter h=new PrintWriter(new FileOutputStream(makepref("defaultStyle.xml")));
	
           _listeBalise.WriteXML(h);
           h.close();
          
           }
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}
private Action SaveDocument()
{
ImageIcon iconOpen = new ImageIcon(makeicon("file_save.gif"));
Action toto = new AbstractAction("Save annoted document...", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	try{
	SimpleFilter m_txtFilter=new SimpleFilter("xmldoc","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showSaveDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION) {
            
            File fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".xmldoc");
	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

	FileOutputStream ostream = new FileOutputStream(fChoosen);
	ObjectOutputStream p = new ObjectOutputStream(ostream);

  	   p.writeUTF(_dtdfile);
           p.writeObject(_listeBalise);
           p.writeObject(_listetag);
           p.writeUTF(_text1.getDocument());
          
           p.close();
           }
           MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
           }
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}
private Action SaveDocument2()
{
ImageIcon iconOpen = new ImageIcon(makeicon("file_save.gif"));
Action toto = new AbstractAction("Save annoted document .", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	try{
	SimpleFilter m_txtFilter=new SimpleFilter("xml","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showSaveDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION) {
            
            File fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".xml");
	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

	PrintWriter ostream = new PrintWriter(new FileOutputStream(fChoosen));
	
  	  /* p.writeUTF(_dtdfile);
           p.writeObject(_listeBalise);
           p.writeObject(_listetag);
           p.writeUTF(_text1.getDocument());*/
        
         // SaveXml.WriteDocument(ostream,_listetag,_listeBalise,_text1.getDocument(),_dtdfile);
          ostream.flush();
          ostream.close();
           /*p.close();*/
           }
           MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
           }
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}
private Action Load()
{
ImageIcon iconOpen = new ImageIcon(makeicon("openb.gif"));
Action toto = new AbstractAction("Load balise ", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	try
	{SimpleFilter m_txtFilter=new SimpleFilter("sav","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showOpenDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION) {
            
            File fChoosen = m_chooser.getSelectedFile();
		MainFrame.this._directorie=m_chooser.getCurrentDirectory();

 FileInputStream istream = new FileInputStream(fChoosen);
	ObjectInputStream p = new ObjectInputStream(istream);
         _dtdfile=p.readUTF();
         _listeBalise=new ListeBalise();
         _listeBalise=(ListeBalise)p.readObject();
         initStyleButton();
          _styleEditBalise.UpDate(_listeBalise);
			}
MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
}
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}
private void initStyleButton()
{
if (_style_bouton!=null) mBalise.remove(_style_Item);
_style_bouton=new StyleButton(_listeBalise,_toolBar,this);
_style_Item=new JMenuItem(_style_bouton.Save());


}
private Action quit()
{
Action toto=new AbstractAction("quit")
{
public void actionPerformed(ActionEvent e) {
	final JDialog myquit=new JDialog(MainFrame.this,"Quit",true);
	JPanel panel=new JPanel(new FlowLayout(FlowLayout.RIGHT));
	JButton save=new JButton("Save");
	 ActionListener hardquit = new ActionListener() 
	 { 
      public void actionPerformed(ActionEvent e) {
      	System.exit(0);
      	}
};
ActionListener hcancel = new ActionListener() { 
      public void actionPerformed(ActionEvent e) 
      {
       if (MainFrame.MAINDEBUG) System.err.println("TOTO");
   myquit.setVisible(false);
    
      }
};
	JButton hquit=new JButton("Quit");
	hquit.addActionListener(hardquit);
	JButton cancel=new JButton("Cancel");
	save.addActionListener(SaveDocument2());
	JLabel label=new JLabel("You gonna to exit from XmlJava???");
	panel.add(label);
	panel.add(save);
	cancel.addActionListener(hcancel);
	panel.add(cancel);
	panel.add(hquit);
	
	myquit.getContentPane().add(panel);
	Dimension d=Toolkit.getDefaultToolkit().getScreenSize();
int height_screen=d.height;
int width_screen=d.width;
float pourcent=(float).5;
Point p=new Point((int)(width_screen*.2),(int)(height_screen*pourcent));
myquit.setLocation(p);
myquit.setSize((int)(width_screen*.5),(int)(height_screen*.2));
	myquit.setVisible(true);
	myquit.pack();
	
	}
};
return toto;
}
private Action LoadDocument()
{
ImageIcon iconOpen = new ImageIcon(makeicon("file_open.gif"));
Action toto = new AbstractAction("Load annoted document(for compatibility only!!!)", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	try
	{SimpleFilter m_txtFilter=new SimpleFilter("xmldoc","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showOpenDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION){
            
            File fChoosen = m_chooser.getSelectedFile();
		MainFrame.this._directorie=m_chooser.getCurrentDirectory();

 FileInputStream istream = new FileInputStream(fChoosen);
	ObjectInputStream p = new ObjectInputStream(istream);
          if (MainFrame.MAINDEBUG) System.err.println("available"+p.available());
         _dtdfile=p.readUTF();
          if (MainFrame.MAINDEBUG) System.err.println("_dtdfile:"+_dtdfile);
          if (MainFrame.MAINDEBUG) System.err.println("available"+p.available());
         
         _listeBalise=new ListeBalise();
         _listeBalise=(ListeBalise)p.readObject();
         initStyleButton();
         _listetag=(ListeTag)p.readObject();
         _text1.setDocument(p.readUTF());
    
           
         _styleEditBalise.UpDate(_listeBalise);
          /*_text1.repaintTag(_listetag);*/
          _listetagihm.SetTag(_listetag,_text1.getDocument(),_dtdtree);
          	
			}
MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
}
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}
private Action About()
{
ImageIcon iconOpen = new ImageIcon(makeicon("about.gif"));
Action toto = new AbstractAction("about", iconOpen) 
{ public void actionPerformed(ActionEvent e) 
	{
		SplashScreen s=new SplashScreen(false);
		};
};
return (toto);
}
private Action LoadDocument3()
{
ImageIcon iconOpen = new ImageIcon(makeicon("file_open.gif"));
Action toto = new AbstractAction("Load Annoted Document", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	try
	{SimpleFilter m_txtFilter=new SimpleFilter("xml","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showOpenDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION) {
            
            File fChoosen = m_chooser.getSelectedFile();
		MainFrame.this._directorie=m_chooser.getCurrentDirectory();
	
	DefaultHandlerLoadXml _reader=new DefaultHandlerLoadXml();
         _reader.lect(fChoosen.getAbsolutePath());
         
         _dtdfile=_reader.getDtdFileName();
           _listeBalise=new ListeBalise();
         String f=fChoosen.getAbsolutePath();
           String filestyle=f.substring(0,f.length()-4);
           filestyle=filestyle.concat("Style.xml");
         
         GeneralReader reader=new GeneralReader();
         reader.AddSerialisable(new EnsembleStyle());
		 	reader.AddSerialisable(new CoupleHash());
		 	reader.AddSerialisable(new GraphicStyle());
  			reader.AddSerialisable(new logique.Style());
      			reader.AddSerialisable(new SemantiqueRule());
      			reader.AddSerialisable(new Balise());
      			reader.AddSerialisable(new ListeBalise());
      			FileReader t=new FileReader(filestyle);
      			
         reader.lect(t);   
         t.close();
         ListeBalise oldliste=_reader.getListeBalise();
         
         
         _listeBalise=(ListeBalise)reader.getResultat();
         _listetag=_reader.getListeTag();
         for (int i=0;i<_listeBalise.size();i++)
         {
          Balise b1=(Balise ) _listeBalise.get(i);
          b1.setListeAttribut(null);
         }
         for (int i=0;i<_listetag.size();i++)
         {
         Tag tag=_listetag.get(i);
         Balise b=_listeBalise.getBaliseByName(tag.getBalise().getName());
             
         if (b==null) {System.err.println("DTD is not on this file");System.exit(0);}
         b.setListeAttribut(tag.getBalise().getListeAttribut());
         tag.setBalise(b);
         
         
        }
        for (int i=0;i<oldliste.size();i++)
         {
           Balise b1=(Balise ) oldliste.get(i);
         
         Balise b=_listeBalise.getBaliseByName(b1.getName());
         
         if (b.getListeAttribut()==null) {b.setListeAttribut(b1.getListeAttribut());}
       
         
        }
 	 _text1.load(new StringReader(_reader.getDocument()));
       
          XmlNode test=new XmlNode();
test.Init(_listetag,_dtdtree);
_listetag=test.toListeTag();
          
      
          
          _styleEditBalise.UpDate(_listeBalise);
          _text1.repaintTag(_listetag);
          _listetagihm.SetTag(_listetag,_reader.getDocument(),_dtdtree);
          initStyleButton();
          
    
          _text1.initLoad();
              _text1.repaintTag(_listetag);
          
		}	
MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
}
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}


public void repaint_mypanel()
{
_text1.repaintTag(_listetag);
_styleEditBalise.UpDate(_listeBalise);
}
public Vector gereCollision(int x,int y)
{ if (MainFrame.MAINDEBUG)  System.err.println("MainFrame::gereCollision");
	
_styleEditBalise.ActivAll(!_listetag.recouvre(x,y));
 Tag _tag=_listetag.search(x,y);
  if (MainFrame.MAINDEBUG) System.err.println(_tag);
 if (_tag!=null) 
 	{
 	Vector v=_dtdtree.getUnder(_tag.getBalise().getName());
 	if (v!=null) {_styleEditBalise.Activ(v);return v;}
 	}
 if (MainFrame.MAINDEBUG) System.err.println("FIN MainFrame::gereCollision");
 return null;
}

public void setBoth(boolean both)
{
 if (MainFrame.MAINDEBUG) System.err.println("MainFrame::setBoth("+both+")");
_listetagihm.setBoth(both);
_listetagihm.SetTag(_listetag,_text1.getDocument(),_dtdtree);
}
/**
 * met a jour les panneau avec un style de preferences
 * @param sa le style par preference
 */
 
private void setPreference()
{
if (_pref.getAttributesPlainText()!=null) _text1.setPlainTextAttr(_pref.getAttributesPlainText().getAttributes());
_listetagihm.setBoth(!_pref.getBoth());
_listetagihm.setFont1(_pref.getAttributesTagBody().getAttributes());
_listetagihm.setFont2(_pref.getAttributesSampleText().getAttributes());
if (_text1!=null && _text1.getDocument()!=null ) _listetagihm.SetTag(_listetag,_text1.getDocument(),_dtdtree);
_styleEditBalise.UpDate(_listeBalise);
_text1.repaintTag(_listetag);
UpDateTag();
}
public Document getDocumentFromSwing()
{
return (_text1.getDocumentFromSwing());
}
private Action Preference()
{
ImageIcon iconOpen = new ImageIcon(makeicon("preference.gif"));
Action toto = new AbstractAction("Preference", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	try
	{ _tabbedPref.init(_pref);
		_tabbedPref.setVisible(true);
		
}
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}
public void ListeTagIhmChange(ListeTagIhmEvent evt)
{
/* if (MainFrame.MAINDEBUG)*/ System.err.println("/**********************LISTETAGIHMCHANGE"+evt.getSemantic()+"***********************/");
if (evt.getSemantic()==ListeTagIhmEvent.SEMANTIQUE_NONSELECTIONNE)
{
_listetag.setActif(null);
UpDateTag();
}else
if (evt.getSemantic()==ListeTagIhmEvent.SEMANTIQUE_SELECTIONNE)
{
select(evt.getAttribute());
viewLigne(evt.getAttribute().getLigne());
_listetag.setActif(null);

}
else if (evt.getSemantic()==ListeTagIhmEvent.SEMANTIQUE_ACTIF)
{
_listetag.setActif(evt.getAttribute());
_text1.setCaret(evt.getAttribute().getFin());

}
else if (evt.getSemantic()==ListeTagIhmEvent.SEMANTIQUE_ACTIF2)
{
_listetag.setActif(evt.getAttribute());
_text1.setCaret(evt.getAttribute().getDebut());

}
 if (MainFrame.MAINDEBUG) System.err.println("fin ListeTagIhmChange");
}
/** 
 * mets a jour la ligne de status 
 * @param status le statut a afficher
 */


public void setStatus(String status)
{
_status.setText(status);
_status.repaint();
}
/**
 * renvoie la liste des tags
 * @result la liste des tags
 *
 */
public ListeTag getTag(){return _listetag;}
private Action LoadFile()
{
ImageIcon iconOpen = new ImageIcon(makeicon("file_new.gif"));
Action toto = new AbstractAction("Load a text document", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	SimpleFilter m_txtFilter=new SimpleFilter("txt","Text Document");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        Thread runner = new Thread() 
        {
	        public void run() {
        	 if (m_chooser.showOpenDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION) 
            	{MainFrame.this.repaint();
            	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

            	File fChoosen = m_chooser.getSelectedFile();
		try {
		 	_listetag=new ListeTag();
                	 
                	 _text1.load(fChoosen);
		 	 if (MainFrame.MAINDEBUG) System.err.println("avant _listetagihm::setTag");
		 	 _text1.repaintTag(_listetag);_text1.initLoad();
			_listetagihm.SetTag(_listetag,_text1.getDocument(),_dtdtree);
			 if (MainFrame.MAINDEBUG) System.err.println("fin _listetagihm::setTag");
		 
          
             
			}
            	catch (Exception ex) {System.out.println(ex);}}
            	MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        }
};
runner.run();
}
};
return (toto);
}
private Action NewDocument()
{
ImageIcon iconOpen = new ImageIcon(makeicon("new_document.gif"));
Action toto = new AbstractAction("new document", iconOpen) 
{ 
	 public void actionPerformed(ActionEvent e) {
    
_listetag=new ListeTag();
_text1.setDocument(new String(""));
_listetagihm.SetTag(_listetag,_text1.getDocument(),_dtdtree);
		_text1.initLoad();
		}; 
	
};
return (toto);
}
private void ActiveStyle(String str)
{
MainFrame.this._listeBalise.changeStyle(str);
MainFrame.this._select=str;
repaint_mypanel();
Component c;
int i=0;
while ((c=MainFrame.this._toolBar.getComponentAtIndex(i++))!=null)
	{
		SmallButtonPress press;
		if (c.getClass().getName().equals("dialogtool.SmallButtonPress"))
		{
		press=(SmallButtonPress)c;
		if (!press.IsMe(str)) 
			{
				press.setInactif();
				press.repaint();
			}
			else {press.setActif();press.repaint();}
		}
		}
		MainFrame.this._toolBar.repaint();
	
}

public Action ChangeStyle(final String str)
{
ImageIcon iconOpen = new ImageIcon(makeicon("toolStyle.gif"));
Action toto = new AbstractAction("Change for "+str+"style", iconOpen) 
{ 
	 public void actionPerformed(ActionEvent e) 
	 {
    	ActiveStyle(str);
	 }

	 
	
};
return toto;
}
private void AddStyle(final String str)
{
    
     if (MainFrame.MAINDEBUG) System.err.println(str);
    _listeBalise.AddStyle(str);
    SmallButtonPress press=new SmallButtonPress(ChangeStyle(str),"Changer de style pour"+str,str);
    _toolBar.add(press);
   
    ActiveStyle(str);
    MainFrame.this._select=new String(str);
      MainFrame.this.repaint();
   MainFrame.this.repaint_mypanel();
    MainFrame.this._toolBar.setVisible(false);
    MainFrame.this._toolBar.setVisible(true);
    
    MainFrame.this._toolBar.setBorderPainted(true);
  
		
}
private void AddStyle(final EnsembleStyle ens)
{
    String str=ens.getStyleName();
     if (MainFrame.MAINDEBUG) System.err.println(str);
    _listeBalise.AddStyle(ens);
    SmallButtonPress press=new SmallButtonPress(ChangeStyle(str),"Changer de style pour"+str,str);
    _toolBar.add(press);
   
  
    MainFrame.this._select=new String(str);
     ActiveStyle(str);
      MainFrame.this.repaint();
   MainFrame.this.repaint_mypanel();
    MainFrame.this._toolBar.setVisible(false);
    MainFrame.this._toolBar.setVisible(true);
    
    MainFrame.this._toolBar.setBorderPainted(true);
  
		
}
private Action NewStyle()
{
ImageIcon iconOpen = new ImageIcon(makeicon("newStyle.gif"));
Action toto = new AbstractAction("New Style", iconOpen) 
{ 
	 public void actionPerformed(ActionEvent e) {
WhichName name=new WhichName("Give a name for this Style",MainFrame.this);
    name.setVisible(true);
     if (MainFrame.MAINDEBUG) System.err.println(name.getValue());
    String str=new String(name.getValue());
 AddStyle(str);
  
		}; 
	
};
return (toto);

}
private Action LoadStyle()
{
ImageIcon iconOpen = new ImageIcon(makeicon("loadStyle.gif"));
Action toto = new AbstractAction("Load Style", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	SimpleFilter m_txtFilter=new SimpleFilter("xmlStyle","Style");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        Thread runner = new Thread() 
        {
	        public void run() {
        	 if (m_chooser.showOpenDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION) 
            	{MainFrame.this.repaint();
            	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

            	File fChoosen = m_chooser.getSelectedFile();
		try {
		 	GeneralReader reader=new GeneralReader();
		 	reader.AddSerialisable(new EnsembleStyle());
		 	reader.AddSerialisable(new CoupleHash());
		 	reader.AddSerialisable(new GraphicStyle());
  			reader.AddSerialisable(new logique.Style());
      			reader.AddSerialisable(new SemantiqueRule());
      			FileReader t=new FileReader(fChoosen);
      			reader.lect(t);
      			EnsembleStyle ensemble=(EnsembleStyle)reader.getResultat();
      			t.close();
      			AddStyle(ensemble);
      			
			}
            	catch (Exception ex) {System.out.println(ex);}}
            	MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        }
};
runner.start();
}
};
return (toto);
}
private Action SaveStyle()
{
ImageIcon iconOpen = new ImageIcon(makeicon("saveStyle.gif"));
Action toto = new AbstractAction("Save current Style", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
     	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
	if (m_chooser.showSaveDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION)
	{
		File fChoosen ;
	  	if (!m_chooser.getSelectedFile().getAbsolutePath().endsWith(".xmlStyle"))
            	{
            		fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".xmlStyle");
            	}
    		else{  fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath());}
	     try { 
	     	EnsembleStyle ensemble=_listeBalise.getEnsembleStyle(MainFrame.this._select);
	     	FileWriter t=new FileWriter(fChoosen);
		PrintWriter pr=new PrintWriter(t,true);
	     	ensemble.WriteXML(pr);
	      	pr.close();
		t.close();
                 } 
            catch (Exception ex) {ex.printStackTrace();}
           
            
      };
      MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
      };
};



return (toto);
}
private Action DeleteStyle()
{
ImageIcon iconOpen = new ImageIcon(makeicon("delStyle.gif"));
Action toto = new AbstractAction("Delete Current Style", iconOpen) 
{ 
	 public void actionPerformed(ActionEvent e) {
    Component c []=MainFrame.this._toolBar.getComponents();
JToolBar b=new JToolBar();
for (int i=0;i<c.length;i++)
{
	SmallButtonPress press;
	 if (MainFrame.MAINDEBUG) System.err.println(c[i]);
	if (c[i]!=null){
	if (c[i].getClass().getName().equals("dialogtool.SmallButtonPress"))
		{
		press=(SmallButtonPress)c[i];
		if (!press.IsMe(MainFrame.this._select)) {
			 if (MainFrame.MAINDEBUG) System.err.println("Ajout"); 
			b.add(c[i]);}
	} 
	else	{ 
		 if (MainFrame.MAINDEBUG) System.err.println("Ajout"); 
		b.add(c[i]);}
	}
}		
 
MainFrame.this.remove(MainFrame.this._toolBar); 
MainFrame.this._toolBar=b;
MainFrame.this.getContentPane().add(_toolBar, BorderLayout.NORTH);
MainFrame.this._select=new String("default");
MainFrame.this._listeBalise.changeStyle(MainFrame.this._select);
repaint_mypanel();
MainFrame.this._toolBar.repaint();
};


		 
	
};
return (toto);
}
private Action EditStyle()
{
ImageIcon iconOpen = new ImageIcon(makeicon("editStyle.gif"));
Action toto = new AbstractAction("Edit Style", iconOpen) 
{ 
	 public void actionPerformed(ActionEvent e) 
	 {
	  if (MainFrame.MAINDEBUG) System.err.println("MainFrame::EditStyle"+MainFrame.this._select);
   EditStyle.setEnsembleStyle(_listeBalise.getEnsembleStyle(MainFrame.this._select));
   EditStyle.setVisible(true);
repaint_mypanel();
		}; 
	
};
return (toto);
}
public Action ExportHTML()
{
ImageIcon iconOpen = new ImageIcon(makeicon("html.gif"));
 Action toto = new AbstractAction("Export to html...", iconOpen) 
 {
      public void actionPerformed(ActionEvent e) {
     HTMLEditorKit m_kit=new HTMLEditorKit();
     final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	
      MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
      if (m_chooser.showSaveDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION)
      {
             File fChoosen ;
	  if (!m_chooser.getSelectedFile().getAbsolutePath().endsWith(".htm"))
            	{
            		fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".htm");
            		
            		}
    else{  fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath());
   
    }
    
	    try {  
	    	
	    	FileWriter t=new FileWriter(fChoosen);
		 		PrintWriter pr=new PrintWriter(t,true);
		 		pr.print("<html><head> <style type=\"text/css\" media=\"screen\"><!--\n");
		 		
		 		SaveHTML.WriteListeBaliseHTML(pr,_listeBalise);
		 		pr.print("--></style>\n</head>");
		 		pr.print(GenerateXML.GenerateHTML(_text1.getDocument(),_listetag,_dtdfile,_dtdtree));
		 		 pr.print("</html>");
		 		 pr.close();
		 		t.close();
	    	
	     
                 } 
            catch (Exception ex) {ex.printStackTrace();}
           
            
      };
      MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
  };
  
      };
    
   return toto;
}

public Action ExportRTF()
{
ImageIcon iconOpen = new ImageIcon(makeicon("rtf.gif"));
 Action toto = new AbstractAction("Export to rtf...", iconOpen) 
 {
      public void actionPerformed(ActionEvent e) {
      RTFEditorKit m_kit=new RTFEditorKit();
     final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	
      MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
      if (m_chooser.showSaveDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION)
      {
              File fChoosen ;
	  if (!m_chooser.getSelectedFile().getAbsolutePath().endsWith(".rtf"))
            	{
            		fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".rtf");
            		
            		}
    else{  fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath());
   
    }
	     try {  OutputStream out = new FileOutputStream(fChoosen);
	     Document m_doc=_text1.getDocumentFromSwing();
              m_kit.write(out, m_doc, 0, m_doc.getLength());
              out.close();
                 } 
            catch (Exception ex) {ex.printStackTrace();}
           
            
      };
      MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
  };
  
      };
    
   return toto;
    }
public  String getDocument()
{
	String generate=GenerateXML.GenerateXML(_text1.getDocument(),_listetag,_dtdfile,_dtdtree);
	return generate;
}
private Action ValidatorStrict()
{
ImageIcon iconOpen = new ImageIcon(makeicon("validS.gif"));
Action toto = new AbstractAction("Open...", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	_validator.Test(GenerateXML.GenerateXML(_text1.getDocument(),_listetag,_dtdfile,_dtdtree),true);
	_validator.setVisible(true);
	}
};
return (toto);
}
private Action Print()
{
ImageIcon iconOpen = new ImageIcon(makeicon("print.gif"));
Action toto = new AbstractAction("Print", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	Printer p=new Printer();
	p.print(MainFrame.this.getDocument());
	}
};
return (toto);
}
private Action Validator()
{
ImageIcon iconOpen = new ImageIcon(makeicon("valid.gif"));
Action toto = new AbstractAction("Open...", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	_validator.Test(GenerateXML.GenerateXML(_text1.getDocument(),_listetag,_dtdfile,_dtdtree),false);
	_validator.setVisible(true);
	}
};
return (toto);
}

private Action LoadFileDTD()
{
ImageIcon iconOpen = new ImageIcon(makeicon("dtd_open.gif"));
Action toto = new AbstractAction("Load DTD File", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	SimpleFilter m_txtFilter=new SimpleFilter("dtd","DTD File");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        Thread runner = new Thread() 
        {
	        public void run() {
        	 if (m_chooser.showOpenDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION)
        	 {
        	 	MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
      	return;
        	 }
            	MainFrame.this.repaint();
            	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

		try {
			File fChoosen = m_chooser.getSelectedFile();
			
			DTDReader DReader=new DTDReader();
			_dtdfile=new String(fChoosen.getPath());
			 System.out.println("_dtdFILE:"+fChoosen);
			 DReader.parseDTD(fChoosen.getAbsolutePath());
			 _dtdtree=new DTDTree();
			 _dtdtree.parseDTD(fChoosen.getAbsolutePath());
			 System.out.println(DReader.getData());
			 _listeBalise=DReader.getData();
			 _listeBalise.setDefaultStyle(_pref.getAttributesTagBody().getAttributes(),true);
			 _styleEditBalise.UpDate(_listeBalise);
			_listetag=new ListeTag();
			_listetagihm.SetTag(_listetag,_text1.getDocument(),_dtdtree);
			initStyleButton();
		      
			}
            	catch (Exception ex) {
                        _dtdvalidator.Test(new String("Erreur dans lecture DTD")+ex.toString());
                        _dtdvalidator.setVisible(true);
                }
            	MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        }
};
runner.start();
}
};
return (toto);
}
/**
 * LectDTD permet de lire un fichier de dtd
 * @param filename la dtd
 */
public void LectDTD(String filename)
{DTDReader DReader=null;
 if (MainFrame.MAINDEBUG) System.err.println("MainFrame::LextDTD"+filename);
try {
			
			 DReader=new DTDReader();
			 
			_dtdfile=new String(filename);
			 System.out.println(filename);
			 DReader.parseDTD(filename);
			  _dtdtree=new DTDTree();
			 _dtdtree.parseDTD(filename);
			 System.out.println(DReader.getData());
		}
            	catch (Exception ex) {
                        _dtdvalidator.Test(new String("Erreur dans lecture DTD")+ex.toString());
                        _dtdvalidator.setVisible(true);
               }
           if (DReader!=null)
           {    try {
               	
			 _listeBalise=DReader.getData();
			 SimpleAttributeSet defaultattr=_pref.getAttributesTagBody().getAttributes();
			 System.out.println("DEFAULT ATTR"+defaultattr);
			 _listeBalise.setDefaultStyle(defaultattr,true);
			 _styleEditBalise.UpDate(_listeBalise);
			_listetag=new ListeTag();
			_listetagihm.SetTag(_listetag,_text1.getDocument(),_dtdtree);
			initStyleButton();
		      
			}
            	catch (Exception ex) {
                        _dtdvalidator.Test(new String("Erreur dans lecture des preference")+ex.toString());
                        _dtdvalidator.setVisible(true);
            }   }
             if (MainFrame.MAINDEBUG) System.err.println("fin MainFrame::LextDTD"+filename);
}
/**
 * mets ajour la listes des tag pour le panneau d'edition
 */
public void UpDateTag()
{
_listetagihm.SetTag(_listetag,_text1.getDocument(),_dtdtree);
_text1.repaintTag(_listetag);

}
/**
 * gere la selection d'un tag
 * @param t le tag selectionn
 */
public void select(Tag t)
{
System.err.println("MainFrame::Select select Tag t "+t.toString());
_text1.repaintTag(_listetag);
_text2.init(t.getBalise(),t);
_text2.getViewport().setVisible(true);
_text1.select(t.getDebut(),t.getFin(),t.getBalise().getAttribut());
_listetagihm.select(t);
gereCollision(t.getDebut(),t.getFin());
copier_balise.setEnabled(true);
_selectione=t;

}
/**
 * enleve un tag de la liste et met a jour les panneau 
 * @param tag le tag a enlever
 * @result vrai si ca c'est bien passer
 */
public boolean remove(Tag tag)
{
boolean result=_listetag.remove(tag);
_text1.repaintTag(_listetag);
_listetagihm.SetTag(_listetag,_text1.getDocument(),_dtdtree);
return result;
}
/**
 * enleve les tag de la liste entourant tag et met a jour les panneau 
 * @param tag le tag englobant
 * @result vrai si ca c'est bien passer
 */
public boolean removeGroup(Tag tag)
{
boolean result=_listetag.removeGroup(tag);
_text1.repaintTag(_listetag);
_listetagihm.SetTag(_listetag,_text1.getDocument(),_dtdtree);
return result;
}
  public void BaliseInserted(StyleEditBaliseEvent evt)
  {
  UpDateChild(evt.getAttribute(),evt.getAttribute().getAttribut());
  }
/**
 * mets jour graphiquement les differentes fenetres avec une position dans le texte
 * @param pos la position dans le texte
 *
 */
public void UpDateChild(int pos,boolean select)
{
 if (MainFrame.MAINDEBUG) System.err.println(_listetag);

Tag t=_listetag.search(pos);
copier_balise.setEnabled(false);

if (t!=null) 
{
	
	 if (MainFrame.MAINDEBUG) System.err.println(t);
	gereCollision(t.getDebut(),t.getFin());
	
	_text2.init(t.getBalise(),t);
	_text2.getViewport().setVisible(true);
	_text1.repaintTag(_listetag);
	if (select) _text1.select(t.getDebut(),t.getFin(),t.getBalise().getAttribut());
	
        if (_listetag.getActif()==null) _listetagihm.select(t) ; else _listetagihm.select(_listetag.getActif());
        
}
	else 
	{
		_text2.getViewport().setVisible(false);
		_text1.repaintTag(_listetag);
	}
}
/**
 * mets a jour la liste des tags Ihm
 */
public void UpDateListe()
{
_listetagihm.SetTag(_listetag,_text1.getDocument(),_dtdtree);
_text1.repaintTag(_listetag);
}
/**
 * defile les panneau pour voir la ligne ligne
 * @param ligne le numero de la ligne 
 */
public void viewLigne(int ligne)
{
 if (MainFrame.MAINDEBUG) System.err.println("ligne a scroller :"+ligne);
_text1.scroll(ligne);
}
/**
 * met a jour le style graphique d'une balise 
 * @param b la balise concerne
 * @param attrM le stylegraphique
 */
private boolean searchTagSup(Vector v,String supname)
{
int taille=v.size();
Tag t;
for (int i=0;i<taille;i++) 
{
t=(Tag)v.get(i);
if (t.getBalise().getName().equals(supname)) return true;
}
return false;
}
public void AddMyTag(Tag tag)
{
_listetag.add(tag);
gereCollision(tag.getDebut(),tag.getFin());
Vector sup=_listetag.getSuperieurTag(tag);
 if (MainFrame.MAINDEBUG) System.err.println(sup);
String tagname=tag.getBalise().getName();
String supname=_dtdtree.getSuperieur(tagname);
if (sup==null || !searchTagSup(sup,supname) )
{
Balise b=_listeBalise.getBaliseByName(supname);
 if (MainFrame.MAINDEBUG) System.err.println("BALISE D ORDRE SUPERIEUR"+supname);
if (b!=null)
{
	 if (MainFrame.MAINDEBUG) 	System.err.println("doSomething():"+b.getRule().doSomething());
	if (tag.getBalise().getRule().doSomething())
	{
		if (tag.getBalise().getRule().autourBalise())
		{
		Tag t=new Tag(b,tag.getDebut(),tag.getFin(),tag.getLigne());
		AddMyTag(t);
		} 
		else if (tag.getBalise().getRule().autourParagraphe())
		{
		Element elem1=_text1.getParagraphe(tag.getDebut());
		Element elem2=_text1.getParagraphe(tag.getFin());
		if (elem1!=null && elem2!=null && elem1==elem2)
			{
			int debut=elem1.getStartOffset();
			int fin=elem1.getEndOffset();
			Tag t=new Tag(b,debut,fin,tag.getLigne());
			AddMyTag(t);
			}
		}
		else 
		if (tag.getBalise().getRule().autourDocument())
		{
			String str=_text1.getDocument();
			int taille=str.length();
			Tag t=new Tag(b,0,taille,0);
			AddMyTag(t);
		}
		else 
		if (tag.getBalise().getRule().autourRegExp())
		{
			String str=_text1.getDocument();
			int debut=tag.getDebut();
			int fin=tag.getFin();
			boolean order1=tag.getBalise().getRule().AvantDebut();
			boolean order2=tag.getBalise().getRule().AvantFin();
			String str1=tag.getBalise().getRule().RegExp1();
			String str2=tag.getBalise().getRule().RegExp2();
			
			int result1=SemantiqueRule.getBeginRegexp(str1,str,debut,order1);
			int result2=SemantiqueRule.getEndRegexp(str2,str,fin,order2);
			System.out.println("DEBUT:"+result1+"FIN:"+result2);
			if (result1!=-1 && result2!=-1){
			
			Tag t=new Tag(b,result1,result2,_text1.getLigne(result1));
			AddMyTag(t);}
		}
	
	}
}}

}
public void UpDateChild(Balise b,MutableAttributeSet attrM)
{
System.out.println("MainFrame::UpDateChild(Balise,MutableAttributSet");
Tag tag=new Tag(b,_text1.get_debut(),_text1.get_fin(),_text1.getLigne(_text1.get_debut()));

_text1.GereFin(_text1.get_fin());
AddMyTag(tag);
XmlNode test=new XmlNode();
test.Init(_listetag,_dtdtree);
_listetag=test.toListeTag();
_text1.setListeTag(_listetag);
_styleEditBalise.Activate(b);
_text2.init(b,tag);
UpDateChild((_text1.get_debut()+_text1.get_fin())/2,true);
new Thread()
{
public void run()
{
_listetagihm.SetTag(_listetag,_text1.getDocument(),_dtdtree);
_text1.repaintTag(_listetag);
}
}.start();
//}
}
/**
 * Cree la bar de menu
 * @result la barre de menu cree
 */
public JMenuBar create_JMenuBar()
	{
	JMenuBar menuBar = new JMenuBar();
	JMenu mFile = new JMenu("File");
    mFile.setMnemonic('f');
	
	
 JMenuItem item =  mFile.add(NewDocument());
 item=mFile.add(LoadFile());
 // item=mFile.add(LoadDocument());
   item=mFile.add(LoadDocument3());
    item=mFile.add(SaveFile());
 //item=mFile.add(SaveDocument());
//item=mFile.add(SaveDocument2());

 item=mFile.add(LoadFileDTD());
  
   mFile.addSeparator();
   mFile.add(ExportHTML());
   mFile.add(ExportRTF());
    mFile.addSeparator();
   mFile.add(Print());
    mFile.addSeparator();
   item=mFile.add(quit());
   mFile.add(item);
   
 JMenu mEdit = new JMenu("Edit");
    mEdit.setMnemonic('e');
copier_balise=new JMenuItem("Copy Balise");
coller_balise=new JMenuItem("Paste Balise");
Action copie_b=new AbstractAction("Copy Balise", 
     new ImageIcon(makeicon("edit_copy.gif"))) 
    { 
      public void actionPerformed(ActionEvent e) {
        coller_balise.setEnabled(true);
         coller_balise.setText(coller_balise.getText()+" "+_selectione.getBalise().getName());
      }
    };
    copier_balise.addActionListener(copie_b);
    copie_b=new AbstractAction("Copy Balise", 
     new ImageIcon(makeicon("edit_copy.gif"))) 
    { 
      public void actionPerformed(ActionEvent e) {
        if (MainFrame.MAINDEBUG) System.err.println(_selectione);
        Tag _tag=_listetag.search(_text1.get_debut(),_text1.get_debut()+_selectione.getTaille());
        Vector v=gereCollision(_text1.get_debut(),_text1.get_debut()+_selectione.getTaille());
        if (v!=null || v.contains(_selectione.getBalise().getName())) _text1.select(_text1.get_debut(),_text1.get_debut()+_selectione.getTaille(),_selectione.getBalise().getAttribut());
 	 if (MainFrame.MAINDEBUG) System.err.println(_tag);
 	
      }
    };
     coller_balise.addActionListener(copie_b);
   
mEdit.add(copier_balise);
mEdit.add(coller_balise);
copier_balise.setEnabled(false);
    Action action = new AbstractAction("Copy", 
     new ImageIcon(makeicon("edit_copy.gif"))) 
    { 
      public void actionPerformed(ActionEvent e) {
        _text1.copy();
      }
    };
    item = mEdit.add(action);  
    item.setMnemonic('c');
    item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, 
      KeyEvent.CTRL_MASK));

    action = new AbstractAction("Cut", 
     new ImageIcon(makeicon("edit_cut.gif"))) 
    { 
      public void actionPerformed(ActionEvent e) {
        _text1.cut();
      }
    };
 
    item = mEdit.add(action);  
    item.setMnemonic('t');
    item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, 
      KeyEvent.CTRL_MASK));

    action = new AbstractAction("Paste", 
     new ImageIcon(makeicon("edit_paste.gif"))) 
    { 
      public void actionPerformed(ActionEvent e) {
        _text1.paste();
      }
    };
    item = mEdit.add(action);  
    item.setMnemonic('p');
    item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, 
      KeyEvent.CTRL_MASK));
      
	_tabbedPref=new TabbedPreference(MainFrame.this);
	_tabbedPref.addPreferenceListener(this);
	 mBalise = new JMenu("Style");
	 mBalise.add(NewStyle());
 	mBalise.add(LoadStyle());
 	mBalise.add(SaveStyle());
 	mBalise.add(DeleteStyle());
 	mBalise.add(EditStyle());
 	
 	mEdit.addSeparator();
 	mEdit.add(Preference());
	if (_style_Item!=null && _style_bouton!=null){
	_style_Item=new JMenuItem(_style_bouton.Save());
	//mBalise.add(_style_Item);
	
}
JMenu mMisc = new JMenu("?");
mMisc.add(new JMenuItem(About()));

   	menuBar.add(mFile);
   	menuBar.add(mEdit);
   	menuBar.add(mBalise);
   	menuBar.add(mMisc);
	menuBar.setVisible(true);
	return menuBar;
	}
/**
 * Cree la bar des boutons
 * @result la barre cree
 */
 public void PreferenceChanged(PreferenceEvent evt)
 {
  if (MainFrame.MAINDEBUG) System.err.println(evt);
 _pref=evt.getAttribute();
 setPreference();
 }
public JToolBar createToolBar()
{
 JToolBar m_toolBar = new JToolBar();
   JButton NewDoc=new SmallButton(NewDocument(),"New Document");
    JButton bOpen = new SmallButton(LoadFile(), "Load texte document ");
    JButton bOpenXML = new SmallButton(LoadDocument3(), "Load annoted document ");
    JButton bSaveXML = new SmallButton(SaveFile(), "Save annoted document");
   JButton rtf = new SmallButton(ExportRTF(), "export to RTF");
   JButton html = new SmallButton(ExportHTML(), "export to HTML");
  
   JButton print = new SmallButton(Print(), "print document");
   
    JButton bOpenDTD = new SmallButton(LoadFileDTD(), "Load a DTD file");
   JButton validS=new SmallButton(ValidatorStrict(),"Valid document with DTD");
   JButton valid=new SmallButton(Validator(),"Valid quickly document");
   
    m_toolBar.add(NewDoc);
    m_toolBar.add(bOpen);
     m_toolBar.add(bOpenXML);
      m_toolBar.add(bSaveXML);
      m_toolBar.addSeparator();
     m_toolBar.add(bOpenDTD);
          m_toolBar.add(rtf);    
           m_toolBar.add(html);
     m_toolBar.add(print);
    m_toolBar.addSeparator();
   m_toolBar.add(_status);
   	m_toolBar.add(validS);
	m_toolBar.add(valid);
   return (m_toolBar);
}
/**
 * met a jour la taille des panneaux
 */
protected void OnSize()
 {
 _split1.setDividerLocation(.5);
_split2.setDividerLocation(.75);
_split3.setDividerLocation(.75);
 }
/**
 * Constructeur de la fenetre
 */
 
public MainFrame()
{
super();
copie_balise=false;
_select=new String("default");
Dimension d=Toolkit.getDefaultToolkit().getScreenSize();
int height_screen=d.height;
int width_screen=d.width;
float pourcent=(float).1;
Point p=new Point((int)(width_screen*pourcent),(int)(height_screen*pourcent));
setLocation(p);
setSize((int)(width_screen*8*pourcent),(int)(height_screen*8*pourcent));
_directorie=new File(".");
 EditStyle=new EditStyleDialog(this);
_status=new JLabel();
_listetag=new ListeTag();
_text1=new TextAreaPane(this);
_text2=new CheckDialog(this);
_styleEditBalise=new StyleEditBalise();
try{_styleEditBalise.addStyleEditBaliseListener(this);}
catch (Exception gg){System.err.println(gg);}
_listetagihm=new ListeTagIhm();
_listetagihm.addListeTagIhmListener(this);
try
{ _split1=new JSplitPane(JSplitPane.VERTICAL_SPLIT,_text2,_styleEditBalise);
  _split1.setDividerLocation(.5);

 _split2=new JSplitPane(JSplitPane.VERTICAL_SPLIT,_text1,_listetagihm);
 _split2.setDividerLocation(.75);

 _split3=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,_split2,_split1);
_split3.setDividerLocation(.75);

this.addWindowListener(new WindowAdapter()
		{
		public void windowClosing(WindowEvent e)
		{
			System.exit(0);
		}
		public void windowDeiconified(WindowEvent e) 
           
           	{
           	OnSize();
           	}
		public void windowOpened(WindowEvent e) 
		{
		OnSize();
		}
           
		}
);


_validator=new XmlValidator(this);
_dtdvalidator=new DTDValidator(this);
_toolBar=createToolBar();

getContentPane().add(_split3, BorderLayout.CENTER);
getContentPane().add(_toolBar, BorderLayout.NORTH);
_menuBar=create_JMenuBar();
setJMenuBar(_menuBar);

setVisible(true);
}
catch (Exception e) {System.err.println(e);System.err.println("Erreur D'initialisation des splitting pane");System.exit(0);}
}

public void init()
{
 if (MainFrame.MAINDEBUG) System.err.println("lecture des preferences");
repaint();
OnSize();
repaint();
//_styleEditBalise.GereDefault();	
try{
	FileReader t=new FileReader(makepref("xmljava.conf"));
      	GeneralReader reader=new GeneralReader();
	reader.AddSerialisable(new Preference());
	reader.AddSerialisable(new myColor());
	reader.AddSerialisable(new GraphicStyle());
  	reader.AddSerialisable(new logique.Style());
      	reader.AddSerialisable(new SemantiqueRule());
      	
      	reader.lect(t);
      	_pref=(Preference)reader.getResultat();
      	t.close();
	
	if (_pref.getDTDFile()!=null) LectDTD(_pref.getDTDFile());
	try{
	String defaultworking=_pref.getDefaultDirectorie();
	File f=new File(defaultworking);
	if (f.isDirectory()) _directorie=f;
	}catch (Exception ee){};
	Vector mcolor=_pref.getColorDefault();
	System.out.println(mcolor);
	_tabbedPref.init(_pref);
	
	 reader=new GeneralReader();
	reader.AddSerialisable(new EnsembleStyle());
	reader.AddSerialisable(new CoupleHash());
	reader.AddSerialisable(new GraphicStyle());
  	reader.AddSerialisable(new logique.Style());
      	reader.AddSerialisable(new SemantiqueRule());
      	t=new FileReader(_pref.getDefaultStyle());
      	reader.lect(t);
      	EnsembleStyle ensemble=(EnsembleStyle)reader.getResultat();
      	t.close();
	AddStyle(ensemble);
      	_listeBalise.AddStyle(ensemble);	
      	setPreference();		
if (mcolor!=null) { initDefaultColorDialog(mcolor);_styleEditBalise.UpDate(_listeBalise);}

//(new SaveXml()).lect(makepref("default.xmlStyle"),_listeBalise);

repaint_mypanel();

}
catch (Exception e){System.out.println(e);};


}

 

public static void main(String [] args)
{
 try
{
SplashScreen splash = new SplashScreen();
splash.finalize();



(new MainFrame()).init();
} 
catch (java.lang.Throwable e){System.err.println(e);}


}
}
