package logique;

import org.xml.sax.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;

public class Preference implements XmlSerialisable
{
private Vector _colorDefault;
private String _defaultDirectorie;
private String _dtdfile;
private String _default_style;
private GraphicStyle _plainText;
private GraphicStyle _tagbody;
private GraphicStyle _sampleText;
private boolean _both;
public boolean getBoth(){return  _both;}
public GraphicStyle getAttributesPlainText(){return  _plainText;}
public GraphicStyle getAttributesTagBody(){return  _tagbody;}
public GraphicStyle getAttributesSampleText(){return  _sampleText;}
public Vector getColorDefault(){return  _colorDefault;}
public String getDefaultDirectorie() {return  _defaultDirectorie;}
public String getDTDFile(){return  _dtdfile;}
public String getDefaultStyle(){return _default_style;}
public Preference(){}
public Preference(GraphicStyle plainText,GraphicStyle tagBody,GraphicStyle sampleText,
		  boolean both,String defaultDirectorie,String dtdFile,Vector color,String defaultstyle)
		  {
		  _plainText=plainText;
		  _tagbody=tagBody;
		 
		  _sampleText=sampleText;
		  _colorDefault=color;
		  _defaultDirectorie=defaultDirectorie;
		  _dtdfile=dtdFile;
		  _both=both;
		  _default_style=new String(defaultstyle);
		}

public String getXMLName(){return "preference";}
public void WriteXML(PrintWriter out)
{
out.write("<preference directorie=\""+_defaultDirectorie+"\" dtdfile=\""+_dtdfile+"\" both=\""+_both+"\" defaultstyle=\""+_default_style+"\" >");
_plainText.WriteXML(out);
_tagbody.WriteXML(out);
_sampleText.WriteXML(out);
for (int i=0;i<_colorDefault.size();i++) {myColor c=new myColor((Color)_colorDefault.get(i)); c.WriteXML(out);}
out.write("</preference>");

}
public void lectXML(Attributes attributes,Vector construct)
{
_defaultDirectorie=attributes.getValue("directorie");
_dtdfile=attributes.getValue("dtdfile");
_both=(attributes.getValue("both")).equals("true");
_default_style=attributes.getValue("defaultstyle");
System.err.println("construct 0"+construct.get(0).getClass().getName());
_plainText=(GraphicStyle)construct.get(0);
System.err.println("construct 1"+construct.get(1).getClass().getName());
_tagbody=(GraphicStyle)construct.get(1);
System.err.println("construct 2"+construct.get(2).getClass().getName());
_sampleText=(GraphicStyle)construct.get(2);
_colorDefault=new Vector();
for (int i=3;i<construct.size();i++)
{
_colorDefault.add(((myColor)construct.get(i))._color);
}
}


}