package logique;
import gnu.regexp.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
import org.xml.sax.*;
public class SemantiqueRule implements XmlSerialisable
{

private boolean do_something;
private boolean autour_balise;
private boolean autour_paragraphe;
private boolean autour_document;
private boolean autour_regexp;
private boolean debut_avant;
private boolean fin_avant;
private String  _regexp1;
private String _regexp2;

public SemantiqueRule()
{
do_something=false;
autour_balise=false;
autour_paragraphe=false;
autour_document=false;
autour_regexp=false;
debut_avant=false;
_regexp1=null;
_regexp2=null;
fin_avant=false;
}
public SemantiqueRule(boolean balise,boolean paragraphe,boolean document,boolean regexp,boolean avant1,boolean avant2,String str1,String str2)
{
do_something=true;
autour_balise=balise;
autour_paragraphe=paragraphe;
autour_document=document;
autour_regexp=regexp;
debut_avant=avant1;
fin_avant=avant2;
if (autour_regexp) _regexp1=new String(str1);
if (autour_regexp) _regexp2=new String(str2);
}
public void setRule(boolean balise,boolean paragraphe,boolean document,boolean regexp,boolean avant1,boolean avant2,String str1,String str2)
{
do_something=true;
autour_balise=balise;
autour_paragraphe=paragraphe;
autour_document=document;
autour_regexp=regexp;
debut_avant=avant1;
fin_avant=avant2;
if (autour_regexp) _regexp1=new String(str1);
if (autour_regexp) _regexp2=new String(str2);
}
public void setSomething(boolean something){do_something=something;}
public void setautourBalise(boolean something){autour_balise=something;}
public void setautourParagraphe(boolean something){autour_paragraphe=something;}
public void setautourDocument(boolean something){autour_document=something;}
public void setautourRegExp(boolean regexp) {autour_regexp=regexp;}
public void setAvantDebut(boolean b){debut_avant=b;}
public void setAvantFin(boolean b) {fin_avant=b;}
public void setRegExp1(String regexp){_regexp1=new String(regexp);}
public void setRegExp2(String regexp){_regexp2=new String(regexp);}
public Object clone()
{
SemantiqueRule result=new SemantiqueRule();
result.do_something=do_something;
result.autour_balise=autour_balise;
result.autour_paragraphe=autour_paragraphe;
result.autour_document=autour_document;
result.autour_regexp=autour_regexp;
result.debut_avant=debut_avant;
result.fin_avant=fin_avant;
if (_regexp1!=null) result._regexp1=new String(_regexp1);
if (_regexp2!=null) result._regexp2=new String(_regexp2);
return result;
}
public boolean doSomething(){return do_something;}
public boolean autourBalise(){return autour_balise;}
public boolean autourParagraphe(){return autour_paragraphe;}
public boolean autourDocument(){return autour_document;}
public boolean autourRegExp(){return autour_regexp;}
public boolean AvantDebut(){return debut_avant;}
public boolean AvantFin(){return fin_avant;}
public String RegExp1(){return _regexp1;}
public String RegExp2(){return _regexp2;}
public static int getEndRegexp(String regexp,String document,int end,boolean order)
{
try
{RE stub=new RE(regexp,0,RESyntax.RE_SYNTAX_EMACS);
REMatch[] resultat=stub.getAllMatches(document,end);
System.err.println("GETENDREGEXP"+resultat);
int result=-1;
if (resultat.length==0) return result;
int [] resultat_int=new int[resultat.length];

for (int i=0;i<resultat.length;i++)
{

if (order) resultat_int[i]=resultat[i].getStartIndex();
else resultat_int[i]=resultat[i].getEndIndex();
}
Arrays.sort(resultat_int);

return (resultat_int[0]);
}
catch (Exception e){System.err.println(e);return -1;}
}

public static int getBeginRegexp(String regexp,String document,int begin,boolean order)
{
	try{
RE stub=new RE(regexp,0,RESyntax.RE_SYNTAX_EMACS);
REMatch[] resultat=stub.getAllMatches(document);
int result=-1;
if (resultat.length==0) return result;
int taille=0;
for (int j=0;j<resultat.length;j++)
{
if (resultat[j].getStartIndex()<begin && resultat[j].getEndIndex()<=begin) taille++;
}

int [] resultat_int=new int[taille];
int ind=0;
for (int i=0;i<resultat.length;i++)
{
if (resultat[i].getStartIndex()<begin && resultat[i].getEndIndex()<=begin) {

if (order) resultat_int[ind]=resultat[i].getStartIndex();
else resultat_int[ind]=resultat[i].getEndIndex();
ind++;
}
}
Arrays.sort(resultat_int);
return resultat_int[taille-1];
}
catch (Exception e){System.err.println(e);return -1;}
}
public String getXMLName(){return "completion";}
public  void WriteXML(PrintWriter _writer)
{
SemantiqueRule r=this;
if (r.doSomething()) 
{
	_writer.print("<completion action=\""+r.doSomething()+"\" ");
	if (r.autourBalise()) _writer.print("insert=\"balise\"/>\n");
	else if (r.autourParagraphe()) _writer.print("insert=\"paragraphe\"/>\n");
	else if (r.autourDocument()) _writer.print("insert=\"document\"/>\n");
	else {
		_writer.print("insert=\"expression\" ");
		_writer.print("avant1=\""+r.AvantDebut()+"\" ");
		_writer.print("regexp1=\""+r.RegExp1()+"\" ");
		_writer.print("avant2=\""+r.AvantFin()+"\" ");
		_writer.print("regexp2=\""+r.RegExp2()+"\" >\n");
		
	     }
}else _writer.print("<completion action=\"false\" />\n");

_writer.flush();
}
public void lectXML(Attributes attributes,Vector construct){
boolean action=attributes.getValue("action").equals("true");
	if (action) System.err.println("Action"+action);
	if (!action) return;
	else 
	{
		
	boolean balise=attributes.getValue("insert").equals("balise");
	boolean paragraphe=attributes.getValue("insert").equals("paragraphe");
	boolean document=attributes.getValue("insert").equals("document");
	boolean regexp=attributes.getValue("insert").equals("expression");
	boolean avant1=false;
	boolean avant2=false;
	String regexp1=null;
	String regexp2=null;
	if (regexp) {
		    avant1=attributes.getValue("avant1").equals("true");
		    avant2=attributes.getValue("avant2").equals("true");
		    regexp1=new String(attributes.getValue("regexp1"));
		    regexp2=new String(attributes.getValue("regexp2"));
		}
		System.err.println("SemantiqueRule("+balise+","+paragraphe+","+document+","+regexp+","+avant1+","+avant2+","+regexp1+","+regexp2+")");
		setRule(balise,paragraphe,document,regexp,avant1,avant2,regexp1,regexp2);
		setSomething(true);
	}
}

		
}