package ihm;
import logique.*;
import xml.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
/**
 * TextAreaPane represente la zone d'edition du document
 */
public class TextAreaPane extends JScrollPane
{	
  public static boolean DEBUGTEXTAREAPANE=false;
  /**
   * gere la couche document vue
   */
  protected JDesktopPane desktop;
  /**
   * affiche le document 
   */
  protected JTextPane m_monitor;
  /**
   * le context d'affichage
   */
  protected StyleContext m_context; 
  /**
   * le document 
   */
  protected MyDefaultStyleDocument m_doc;
  /**
   * la gestion RTF du document 
   */
  protected StyledEditorKit m_kit;
  /**
   * le debut de la zone d'edition 
   */
  protected int deb_caret;
  /** 
   * la fin de la zone d'edition 
   */
  protected long mytime;
  protected int fin_caret;

  private int old_ligne;
  private int old_number_ligne;
  
  protected boolean shift;
  protected boolean mouse;
  protected boolean haschange;
  /**
   * la fenetre mere
   */
  protected MainFrame _master;
 MutableAttributeSet PlainTextStyle;
  
  public Document getDocumentFromSwing() {return getStyledDocument();}


  public void scroll(int l)
  {
  	
  JScrollBar _scroll=getVerticalScrollBar();
  if (_scroll==null) return;
  int max=_scroll.getMaximum();
  int nb_ligne=m_doc.getLigne(getDocument().length());
  
   int nvalue=(l*max)/nb_ligne;
 Dimension d=getViewport().getExtentSize();
  int modulo=max/d.height;

  Point p=getViewport().getViewPosition();
  
  

  if ((nvalue-d.height/2)<0)  nvalue=0;
  else nvalue=nvalue-d.height/2;
  _scroll.setValue(nvalue);
    repaint();      

  }
 
public int getLigne(int i){return m_doc.getLigne(i);}
 
 public void setNbLigneIHM(int caract) {_master.setStatus("Ligne :"+m_doc.getLigne(caract));}
  /**
   * gere la modification du document par rapport a l'emplacement des tags
   *
   */

/**
 * le constructeur , on passe la fenetre mere en parametre 
 */
 public TextAreaPane(MainFrame master)  
{
	super(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
	      JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
	mytime=0;
	shift=false;
	mouse=false;
	setSize(600, 400);
 	m_monitor = new JTextPane();
 	PlainTextStyle=new SimpleAttributeSet();
	      _master=master;
	
 	m_kit = new StyledEditorKit();
  	m_monitor.setEditorKit(m_kit);
	m_context = new StyleContext();
	m_doc = new MyDefaultStyleDocument(m_context,_master.getTag(),_master);
	
   	m_monitor.setDocument(m_doc);
   	
  	
    	m_monitor.setDoubleBuffered(true);
    	/////***************** TODO CHECKER LISTENER ******************/

    /*	m_monitor.addKeyListener(new KeyListener()
    	{
	public void keyPressed(KeyEvent e) 
          {System.out.println(shift && mouse);
         haschange=true;
         
          if (e.getKeyCode()==KeyEvent.VK_SHIFT) shift=true;
          } 
	public void keyReleased(KeyEvent e) 
           {System.out.println(shift && mouse);
          if (e.getKeyCode()==KeyEvent.VK_SHIFT) shift=false;
          } 
	public void keyTyped(KeyEvent e) 
            {} 

});*/
haschange=false;
m_monitor.addMouseListener(new MouseListener()
    	{
public	void mouseClicked(MouseEvent e) 
         {System.out.println(shift && mouse);mouse=true;
         
         
         
         
         }
 public void mouseEntered(MouseEvent e) {} 
public void mouseExited(MouseEvent e) {}
 public void mousePressed(MouseEvent e)  { 
    System.out.println(shift && mouse);mouse=true;}
 public void mouseReleased(MouseEvent e) 
 {System.out.println(shift && mouse);
 mouse=false;
 } 
});
	m_monitor.addCaretListener(new CaretListener()
	{
	 public void caretUpdate(CaretEvent e)
	 {
	if (DEBUGTEXTAREAPANE) System.err.println("HEREHERE");
	try 
	{int x=0;
	int y=0;
	
	
	if (e.getDot()<=e.getMark()) {x=e.getDot();y=e.getMark();}
	else {y=e.getDot();x=e.getMark();}
	
	 deb_caret=x;
	 fin_caret=y;
	_master.gereCollision(x,y);
	
	
	setNbLigneIHM(deb_caret);
	
	/////***************** TODO CHECKER LISTENER ******************/
	
	 if (x==y) 
	 {
	 long now=System.currentTimeMillis();
	 if (Math.abs(mytime-now)<500)
	 {
	//double click
	}else {
		mytime=now;
		
	}
	if (shift && mouse) _master.UpDateChild(x,true) ;else
	_master.UpDateChild(x,false);

	 }
	//////////TODO
	
	 System.out.println(e);} catch (Exception ev){System.err.println(ev);};
	}
	}
	);
	

setViewportView(m_monitor);	
setVisible(true);
}
public void setListeTag(ListeTag tl)
{
	m_doc.setListeTag(tl);

}
public void setDot(int i)
{
m_monitor.getCaret().setDot(i);


}
/**
 * gere la selection d'un morceau de texte (passage en gras)
 */
public void  select(int selectionStart,
                   int selectionEnd,SimpleAttributeSet attr)
                {
            Color foreground=StyleConstants.getForeground(attr);
            Color background=StyleConstants.getBackground(attr);
            
            SimpleAttributeSet result=new SimpleAttributeSet();
            StyleConstants.setForeground(result,Color.white);
            StyleConstants.setBackground(result,
            new Color(0,
            		0,
            		132)
            );    
                        getStyledDocument().setAttributeSet(result,selectionStart,selectionEnd);  
                 deb_caret=selectionStart;
	 fin_caret=selectionEnd;
	_master.gereCollision(deb_caret,fin_caret);
}
public void  setCaret(int selectionStart)
                {
            
                 deb_caret=selectionStart;
	 fin_caret=selectionStart;
	
	
	_master.gereCollision(deb_caret,fin_caret);
	
	m_monitor.setCaretPosition(selectionStart);
m_monitor.requestFocus();
}

/**
 * gere l'operation couper dans le document 
 */        
public void cut() {
        this.m_monitor.cut();
      }
/**
 * gere l'operation coller dans le document
 */
public void paste() {
        this.m_monitor.paste();
      }
/**
 * gere l'operation copy dans le document 
 */
public void copy() {
        this.m_monitor.copy();
      }
public void initLoad()
{
		if (DEBUGTEXTAREAPANE)System.err.println("TextAreaPane::initload");
   
   m_doc.setTag(_master.getTag());
   
    
}    
/**
 * permet de charger dans le document un fichier 
 */
public synchronized void load(File fChoosen)
{
	if (DEBUGTEXTAREAPANE)System.err.println("TextAreaPane::load(File)");
try
{
	
	
   FileReader in = new FileReader(fChoosen);
   load(in);
   
 
} 
catch (Exception f) {System.out.println("TextAreaPane ::Load \n"+f);};
}
public MyDefaultStyleDocument getStyledDocument()
{
return (MyDefaultStyleDocument) m_monitor.getStyledDocument();
}
public synchronized void load(Reader in)
{
if (DEBUGTEXTAREAPANE)System.err.println("TextAreaPane::load(Reader)");
try
{
	char [] buff=new char[4096];
	try{    
	MyDefaultStyleDocument d=getStyledDocument();
	d.remove (0,d.getLength());
	
   	} catch(Exception ev) {System.err.println(ev);}
   //m_monitor.read(in,  new MyDefaultStyleDocument());
   int nb=0;
   String result=new String();
   boolean out=true;
   while(out)
   { 
   	nb=in.read(buff);
   	if (nb==-1) out=false;
   	else result=result+new String(buff,0,nb);
   	
   }
   setDocument(result);
  m_doc.setTag(_master.getTag());
   	
   in.close();	
   if (DEBUGTEXTAREAPANE)System.err.println("FIN DE TextAreaPane::load(Reader)");
  
} 
catch (Exception f) {System.out.println("TextAreaPane ::Load \n"+f);};
}


/**
 * renvoie le debut d'une zone selectionner
 */
public int get_debut(){return deb_caret;}
/** 
 * renvoie la fin d'une zone selectionner
 */
public int get_fin(){return fin_caret;}

/**
 * met a jour un morceau de document (entre debut et fin) avec un attribut graphique (attrM)
 * renvoie un booleen de controle
 */


public boolean  setAttributeSet2(MutableAttributeSet attrM) 
{
      long profile=System.currentTimeMillis();	
//System.out.println("setAttributeSet(MutableAttributSet)");

      getStyledDocument().setCharacterAttributes(0,getStyledDocument().getLength(), attrM, false);
     if (DEBUGTEXTAREAPANE)System.err.println("End of setAttributeSet(MutableAttributSet)"+(System.currentTimeMillis()-profile));

        return true;
  
}
/**
 * met a jour un morceau de document(entre debut et fin ) avec un attribut graphique d'une balise
 * renvoie un booleen de controle
 */
public boolean  setAttributeSet(Balise b,int debut,int fin) 
{

   return(getStyledDocument().setAttributeSet(b.getAttribut(),debut,fin));

}
public boolean  setAttributeSetActif(Balise b,int debut,int fin) 
{

SimpleAttributeSet simple=(SimpleAttributeSet)b.getAttribut().clone();
StyleConstants.setBackground(simple, Color.red);
StyleConstants.setForeground(simple,Color.black);

          
   return(getStyledDocument().setAttributeSet(simple,debut,fin));

}
/**
 * repaint tous les tags du document 
 */
public void repaintTag(ListeTag tag)
{
 long profile=System.currentTimeMillis();	
//System.out.println("repaintTag(ListeTag)");
 
try{
//Clean();
 if (DEBUGTEXTAREAPANE)System.err.println(getStyledDocument().getClass().getName());
getStyledDocument().ApplyForAll(PlainTextStyle);
 if (DEBUGTEXTAREAPANE)System.err.println("clean du doc "+(System.currentTimeMillis()-profile));
}catch (Exception e ) {System.out.println(e);}
for (int i=0;i<tag.getListeTag().size();i++)
{
Tag t=tag.get(i);
try{
if (tag.getActif()!=null && tag.getActif()==t) setAttributeSetActif(t.getBalise(),t.getDebut(),t.getFin());
else setAttributeSet(t.getBalise(),t.getDebut(),t.getFin());
} catch (Exception ee) {System.err.println(ee);}
}
 if (DEBUGTEXTAREAPANE)System.err.println("End of repaintTag(ListeTag)"+(System.currentTimeMillis()-profile));

}
/*public void repaintTag2(ListeTag tag)
{
long profile=System.currentTimeMillis();	
//System.out.println("repaintTag2(ListeTag)");
 getStyledDocument().setCharacterAttributes(0,getStyledDocument().getLength(), PlainTextStyle, true);
    
for (int i=0;i<tag.getListeTag().size();i++)
{
Tag t=tag.get(i);

setAttributeSet(t.getBalise(),t.getDebut(),t.getFin());
}
if (DEBUGTEXTAREAPANE)System.err.println("End of repaintTag(ListeTag)"+(System.currentTimeMillis()-profile));

}*/
/**
 * met a jour la selection(debut fin) avec un attribut graphique 
 */
public boolean  setAttributeSet(MutableAttributeSet attrM) 
{
   
//System.out.println("debut :"+deb_caret+" fin :"+fin_caret);
    if ( deb_caret != fin_caret)
    {
     getStyledDocument().setCharacterAttributes(deb_caret, fin_caret - deb_caret, 
        attrM, false);
        return true;
    } 
  return false;
}
public void setPlainTextAttr(MutableAttributeSet attr )
{
	if (DEBUGTEXTAREAPANE)System.err.println("TextAreaPane::setPlainTextAttr"+attr);
	PlainTextStyle=attr;
	getStyledDocument().ApplyForAll(PlainTextStyle);

	
     
}
/**
 * nettoie le document de tous les attributs graphiques
 */
public synchronized void  Clean() 
{
		if (DEBUGTEXTAREAPANE)System.err.println("TextAreaPane::Clean()");
 try{
 if (DEBUGTEXTAREAPANE)System.err.println("TextAreaPane::Clean()");
 MutableAttributeSet attr=new SimpleAttributeSet();
 
 getStyledDocument().ApplyForAll(attr);


    
      } catch (Exception e){System.err.println("Clean Echou"+e.toString()+e.getMessage());}
     
  }
  

/**
 * reserve
 */  
public void GereFin(int i)
{
MyDefaultStyleDocument doc=getStyledDocument();
int taille=doc.getLength();
if (taille==i)
{
//doc.insert(
}
}
/**
 * renvoie la chaine de caractere representant le document 
 */
public String getDocument()
{
try
{
if (DEBUGTEXTAREAPANE)System.err.println("String::getDocument()");

MyDefaultStyleDocument d=getStyledDocument();
if (d==null) return "";
if (DEBUGTEXTAREAPANE)System.err.println("fin::String::getDocument()"+d.getLength());
return (d.getText(0,d.getLength()));
}
catch (Exception b) {System.err.println("getDocument()");return new String("");}
}
public Element getParagraphe(int caret)
{
return getStyledDocument().getParagraphElement(caret);
}
public void setDocument(String df)
{
try
{

MyDefaultStyleDocument d=getStyledDocument();
try {d.remove (0,d.getLength());} catch (Exception ff) {System.err.println("setDocument"+ff);};

if (DEBUGTEXTAREAPANE)System.err.println("On essayer d 'inserer"+df.length());
d.insertString(0,df,new SimpleAttributeSet() );

}
catch (Exception b) {System.err.println("setDocumentb"+b);}
}

}

class MyCaretEvent  extends CaretEvent
{
	
int dot;int mark;
MyCaretEvent(JTextComponent c,int dot,int mark) {
            super(c);
            this.dot=dot;
            this.mark=mark;
        }

        

        

        public final int getDot() {
            return dot;
        }

        public final int getMark() {
            return mark;
        }
}