package logique;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
import org.xml.sax.*;
public class GraphicStyle implements XmlSerialisable 

{
private static final String style="GraphicsStyle";
private static final String fontname="fontname";
private static final String fontsize="fontsize";
private static final String underline="underline";
private static final String bold="bold";
private static final String italic="italic";
private static final String strikethrough="strikethrough";
private static final String subscript="subscript";
private static final String superscript="superscript";
private static final String foreground="foreground";
private static final String background="background";
private  static Color htmlcolor2javacolor(String s)
{
String strback=s.substring(1) ;
Color col=new Color(Integer.parseInt(strback,16));
return col;
}

protected SimpleAttributeSet _simple_attributeSet;
public Object clone()
{
GraphicStyle result=new GraphicStyle((SimpleAttributeSet)_simple_attributeSet.clone());
return result;
}
public GraphicStyle()
{
_simple_attributeSet=new SimpleAttributeSet();
StyleConstants.setForeground(_simple_attributeSet, Color.black);
StyleConstants.setBackground(_simple_attributeSet,Color.white);
}
public GraphicStyle(SimpleAttributeSet s)
{
_simple_attributeSet=s;
}
public SimpleAttributeSet getAttributes(){return _simple_attributeSet;}
public void setAttributes(SimpleAttributeSet s)
{
_simple_attributeSet=s;
}
public  void WriteXML(PrintWriter out)
{
SimpleAttributeSet attr=_simple_attributeSet;
out.write("<"+style+" ");
String fonts=StyleConstants.getFontFamily(attr);
out.write(new String(fontname+"=\""+fonts+"\" "));
int sizei=StyleConstants.getFontSize(attr);
out.write(new String(fontsize+"=\""+sizei+"\" "));
String col=new String("#"+Integer.toHexString(StyleConstants.getForeground(attr).getRGB()&16777215));
out.write(new String(foreground+"=\""+col+"\" "));
col=new String("#"+Integer.toHexString(StyleConstants.getBackground(attr).getRGB()&16777215));
out.write(new String(background+"=\""+col+"\" "));
String at=new String(underline+"=\""+StyleConstants.isUnderline(attr)+"\" ");
out.write(at);
 at=new String(bold+"=\""+StyleConstants.isBold(attr)+"\" ");
out.write(at);
 at=new String(italic+"=\""+StyleConstants.isItalic(attr)+"\" ");
out.write(at);
 at=new String(superscript+"=\""+StyleConstants.isSuperscript(attr)+"\" ");
out.write(at);
 at=new String(subscript+"=\""+StyleConstants.isSubscript(attr)+"\" ");
out.write(at);
 at=new String(strikethrough+"=\""+StyleConstants.isStrikeThrough(attr)+"\" ");
out.write(at);
out.write("/>\n");
out.flush();
}
public String getXMLName(){return style;}
private String getHtmlColor(Color c)
{
int red=c.getRed();
int blue=c.getBlue();
int green=c.getGreen();
String red_s=Integer.toHexString(red);
String blue_s=Integer.toHexString(blue);
String green_s=Integer.toHexString(green);
if (red_s.length()==1) red_s="0"+red_s;
if (blue_s.length()==1) blue_s="0"+blue_s;
if (green_s.length()==1) green_s="0"+green_s;
return "#"+red_s+blue_s+green_s;


}
public  void WriteStyleHTML(PrintWriter out)
{
SimpleAttributeSet attr=_simple_attributeSet;
out.write(" { ");

String fonts=StyleConstants.getFontFamily(attr);
out.write(new String("font-family:\""+fonts+"\";"));
int sizei=StyleConstants.getFontSize(attr);
out.write(new String("font-size:"+sizei+";"));
String col=new String(getHtmlColor(StyleConstants.getForeground(attr)));
out.write(new String("color:"+col+";"));
col=new String(getHtmlColor(StyleConstants.getBackground(attr)));
out.write(new String("background-color:"+col));
if (StyleConstants.isUnderline(attr))
{String at=new String(";text-decoration:underline");
out.write(at);}
if (StyleConstants.isItalic(attr))
{String at=new String(";font-style:italic");
out.write(at);}
if (StyleConstants.isItalic(attr))
{String at=new String(";font-weight:bold");
out.write(at);}
out.write("}\n");
out.flush();
}
public static GraphicStyle IsMe(String s)
{
if (s.equals(style)) return new GraphicStyle();
return null;
}
public void lectXML(Attributes attributes,Vector construct)
{
SimpleAttributeSet attr=new SimpleAttributeSet();

	String font=attributes.getValue("fontname");
	int taille=Integer.parseInt(attributes.getValue("fontsize"));
	Color fore=htmlcolor2javacolor(attributes.getValue("foreground"));
	Color back=htmlcolor2javacolor(attributes.getValue("background"));
	boolean under=attributes.getValue("underline").equals("true");
	boolean bold=attributes.getValue("bold").equals("true");
	boolean italic=attributes.getValue("italic").equals("true");
	boolean superscript=attributes.getValue("superscript").equals("true");
	boolean subscript=attributes.getValue("subscript").equals("true");
	boolean strikethrough=attributes.getValue("strikethrough").equals("true");
	StyleConstants.setFontFamily(attr,font);
        StyleConstants.setBackground(attr,back);
	StyleConstants.setForeground(attr,fore);
        StyleConstants.setFontSize(attr,taille);
        StyleConstants.setUnderline(attr,under);
        StyleConstants.setBold(attr,bold); 
        StyleConstants.setItalic(attr,italic);
        StyleConstants.setSuperscript(attr,superscript);
        StyleConstants.setSubscript(attr,subscript);
        StyleConstants.setStrikeThrough(attr,strikethrough);
     setAttributes(attr);   
}

}